<?php

class View { // classe abstraite pour les vues
	protected $_route; // variable protégée contenant le résultat de l'analyse de la requête (dans un tableau)
	protected $data = array(); // variable protégée contenant des données, sous forme de tableau
	
	public function __construct($route) { // le constructeur
		$this->_route = $route; // on stocke  la route donnée en paramètre dans la variable protégée $_route
	}
	
	public function display() { // va générer un affichage en fonction des paramètres de la route
		$viewFile = ROOT . "/app/view/" . $this->_route["controller"] . "/" . $this->_route["action"] . ".html"; // on va chercher la vue dans app/view/le_nom_du_contrôleur/ce_qu_on_veut_faire.html (le *.html est là pour indiquer qu'aucun calcul n'est réalisé dans ces pages, qu'elles n'ont qu'une fonction d'affichage. Mais on pourra utiliser du PHP pour afficher des noms de variables (<?php echo $this->profil->pseudo; ? >)
	
		if(file_exists($viewFile)) { // le fichier existe bel et bien, on peut l'inclure
			include($viewFile);
		}
		else { // le fichier n'existe pas, on lève une exception avec un message d'erreur/excuse
			throw new DomainException("Vue introuvable - " . $viewFile);
		}
	}
	
	public function __set($key, $value) { // méthode magique permettant de mettre une valeur à un attribut donné, de façon identique pour tous les attributs. Cela évite de devoir définir 15000 setters pour toutes les variables. PHP le fait automatiquement, si c'est pas gentil ça ! ^^
		$this->data[$key] = $value;
	}
	
	public function __get($key) { // idem, mais pour les getters. :-)
		if(isset($this->data[$key]))
			return $this->data[$key];
		else
			return null;
	}
}
